<template>
  <div class="div-search">
    <input
      type="text"
      placeholder="Buscar Gif"
      class="
        placeholder:italic placeholder:text-slate-400
        block
        bg-white
        w-full
        border border-slate-300
        rounded-md
        py-2
        pl-9
        pr-3
        shadow-sm
        focus:outline-none focus:border-sky-500 focus:ring-sky-500 focus:ring-1
        sm:text-sm
      "
      v-model="newRecord"
      @keyup.enter="newSerch"
    />
  </div>
   <div class="div-search">
    <p class="text-blue-600">Busquedas anteriores: </p>
      <span class="box-decoration-slice bg-gradient-to-r from-indigo-600 to-pink-500 text-white px-2 mx-1 " v-for="recorts in allRecorts"
          :key="recorts">
      {{recorts}}
    </span>
   </div>
  <hr class="div-search" />
  <div class="grid grid-cols-5 gap-4 div-search">
    <div
      class="h-4  md:h-20 lg:h-40 w-4 md:w-10 lg:w-80 rounded-lg fonImg shadow-lg shadow-blue-500/50 hover:shadow-red-500/50"
      v-for="gif in gifs"
      :key="gif.id"
      :style="`background-image: url('${gif.images.original.url}')`"
    ></div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      keyApi: "p7Uf0UXKqvHQwJSnYh4S2mtuRqFhUYbw",
      search: "dog",
      newRecord:'',
      allRecorts:[],
      allStorage: '',
      gifs: {
        type: Array,
      },
    };
  },
  methods: {
    newSerch(){
      this.search = this.newRecord;
      this.newRecord=""
      this.getData();
    },
    getData() {
   
      console.log("storage",this.allStorage)
      fetch(
        `https://api.giphy.com/v1/gifs/search?api_key=${this.keyApi}&q=${this.search}&limit=40`
      )
        .then((response) => response.json())
        .then((result) => {
          this.gifs = result.data;
          this.saveLocal()
          
        });
    },
    saveLocal(){
      
     if(localStorage.getItem("names") != null){
            console.log("entro",localStorage.getItem("names"))
          this.allRecorts = JSON.parse(localStorage.getItem("names"));
          const valRecorts  = this.allRecorts.some( element => element === this.search )
           if(!valRecorts){
              this.allRecorts.push(this.search)
              console.log(this.allRecorts)

              localStorage.setItem("names", JSON.stringify(this.allRecorts))
           }
      }else{
        console.log("else")
         const valRecorts  = this.allRecorts.some( element => element === this.search )
        console.log(valRecorts)
          if(!valRecorts){
          this.allRecorts.push(this.search)
          console.log(this.allRecorts)
          localStorage.setItem("names", JSON.stringify(this.allRecorts))
          }
      }


    }
  },
  beforeMount() {
    this.getData();
  },
};
</script>

<style>
.div-search {
  margin: 10px 50px;
}
.fonImg{
  background-repeat: no-repeat;
  background-size: 100% 100%;
}
</style>